(* Special Abbreviations for FormCalc *) 
 
 
Sq[g1] ^=g12; 
Sq[g2] ^=g22; 
Sq[g3] ^=g32; 
Conjugate[Ye[a___]] ^= YeC[a]; 
Conjugate[YeC[a___]] ^= Ye[a]; 
Sq[Ye[a___]] ^=Ye2[a]; 
Conjugate[Yd[a___]] ^= YdC[a]; 
Conjugate[YdC[a___]] ^= Yd[a]; 
Sq[Yd[a___]] ^=Yd2[a]; 
Conjugate[Yu[a___]] ^= YuC[a]; 
Conjugate[YuC[a___]] ^= Yu[a]; 
Sq[Yu[a___]] ^=Yu2[a]; 
Conjugate[Lam5] ^= Lam5C; 
Conjugate[Lam5C] ^= Lam5; 
Sq[Lam5] ^=Lam52; 
Conjugate[mHd2] ^= mHd2C; 
Conjugate[mHd2C] ^= mHd2; 
Sq[mHd2] ^=mHd22; 
Conjugate[mHu2] ^= mHu2C; 
Conjugate[mHu2C] ^= mHu2; 
Sq[mHu2] ^=mHu22; 
Conjugate[Lam1] ^= Lam1C; 
Conjugate[Lam1C] ^= Lam1; 
Sq[Lam1] ^=Lam12; 
Conjugate[Lam4] ^= Lam4C; 
Conjugate[Lam4C] ^= Lam4; 
Sq[Lam4] ^=Lam42; 
Conjugate[Lam3] ^= Lam3C; 
Conjugate[Lam3C] ^= Lam3; 
Sq[Lam3] ^=Lam32; 
Conjugate[Lam2] ^= Lam2C; 
Conjugate[Lam2C] ^= Lam2; 
Sq[Lam2] ^=Lam22; 
Sq[v] ^=v2; 
Sq[ZZ[a___]] ^=ZZ2[a]; 
Conjugate[ZW[a___]] ^= ZWC[a]; 
Conjugate[ZWC[a___]] ^= ZW[a]; 
Sq[ZW[a___]] ^=ZW2[a]; 
Sq[ZP[a___]] ^=ZP2[a]; 
Conjugate[ZDL[a___]] ^= ZDLC[a]; 
Conjugate[ZDLC[a___]] ^= ZDL[a]; 
Sq[ZDL[a___]] ^=ZDL2[a]; 
Conjugate[ZDR[a___]] ^= ZDRC[a]; 
Conjugate[ZDRC[a___]] ^= ZDR[a]; 
Sq[ZDR[a___]] ^=ZDR2[a]; 
Conjugate[ZUL[a___]] ^= ZULC[a]; 
Conjugate[ZULC[a___]] ^= ZUL[a]; 
Sq[ZUL[a___]] ^=ZUL2[a]; 
Conjugate[ZUR[a___]] ^= ZURC[a]; 
Conjugate[ZURC[a___]] ^= ZUR[a]; 
Sq[ZUR[a___]] ^=ZUR2[a]; 
Conjugate[ZEL[a___]] ^= ZELC[a]; 
Conjugate[ZELC[a___]] ^= ZEL[a]; 
Sq[ZEL[a___]] ^=ZEL2[a]; 
Conjugate[ZER[a___]] ^= ZERC[a]; 
Conjugate[ZERC[a___]] ^= ZER[a]; 
Sq[ZER[a___]] ^=ZER2[a]; 
Conjugate[el] ^= elC; 
Conjugate[elC] ^= el; 
Sq[el] ^=el2; 
Conjugate[TW] ^= TWC; 
Conjugate[TWC] ^= TW; 
Sq[TW] ^=TW2; 
Conjugate[betaH] ^= betaHC; 
Conjugate[betaHC] ^= betaH; 
Sq[betaH] ^=betaH2; 
Conjugate[aS] ^= aSC; 
Conjugate[aSC] ^= aS; 
Sq[aS] ^=aS2; 
Sq[aEWinv] ^=aEWinv2; 
Conjugate[MassVWp] ^= MassVWpC; 
Conjugate[MassVWpC] ^= MassVWp; 
Sq[MassVWp] ^=MassVWp2; 
Sq[Gf] ^=Gf2; 
Sq[MassHp[a___]] =MassHp2[a]; 
Sq[MassFv[a___]] =MassFv2[a]; 
Sq[MassFd[a___]] =MassFd2[a]; 
Sq[MassFu[a___]] =MassFu2[a]; 
Sq[MassFe[a___]] =MassFe2[a]; 
Sq[MassG0] =MassG02; 
Sq[Masshh] =Masshh2; 
Sq[MassA0] =MassA02; 
Sq[MassH0] =MassH02; 
Sq[MassVZ] =MassVZ2; 
Sq[MassVWp] =MassVWp2; 
Cos[ThetaW] ^= CW; 
Sin[ThetaW] ^= SW; 
A[x_]:=ToExpression["A"<>ToString[InputForm[x]]]; 
 
 
 (* Dependences *) 
 
Dependences = 
 {ZZ[index1_Integer, index2_Integer] :> {{Cos[ThetaW], -Sin[ThetaW]}, {Sin[ThetaW], Cos[ThetaW]}}[[index1,index2]], ZW[index1_Integer, index2_Integer] :> {{1/Sqrt[2], 1/Sqrt[2]}, {I/Sqrt[2], (-I)/Sqrt[2]}}[[index1,index2]]}
 
DependencesOptional = 
 {g1 -> e*Sec[ThetaW], g2 -> e*Csc[ThetaW], ZP[index1_Integer, index2_Integer] :> {{-Cos[beta], Sin[beta]}, {Sin[beta], Cos[beta]}}[[index1,index2]]}
 
DependencesNum = 
 {g1 -> e*Sec[ThetaW], g2 -> e*Csc[ThetaW], g3 -> 2*Sqrt[AlphaS]*Sqrt[Pi], e -> 2*Sqrt[aEWinv^(-1)]*Sqrt[Pi], v -> 2*Sqrt[Mass[VWp]^2/g2^2], ThetaW -> ArcSin[Sqrt[1 - Mass[VWp]^2/Mass[VZ]^2]], Mass[VWp] -> Sqrt[Mass[VZ]^2/2 + Sqrt[-((Pi*Mass[VZ]^2)/(Sqrt[2]*aEWinv*Gf)) + Mass[VZ]^4/4]]}
 
 
(* Masses *) 
 
MassesSARAH = { 
 MassVG[generation_] ->MassGiven[VG], 
MassgG[generation_] ->MassGiven[gG], 
MassFv[1][generation_] ->MassGiven[Fv[1]], 
MassFv[2][generation_] ->MassGiven[Fv[2]], 
MassFv[3][generation_] ->MassGiven[Fv[3]], 
MassG0[generation_] ->MassGiven[G0], 
Masshh[generation_] ->MassRead[hh], 
MassA0[generation_] ->MassGiven[A0], 
MassH0[generation_] ->MassGiven[H0], 
MassVP[generation_] ->MassGiven[VP], 
MassVZ[generation_] ->MassGiven[VZ], 
MassgP[generation_] ->MassGiven[gP], 
MassgZ[generation_] ->MassGiven[gZ], 
MassgWp[generation_] ->MassGiven[gWp], 
MassgWpC[generation_] ->MassGiven[gWpC], 
MassHp[1][generation_] ->MassGiven[Hp[1]], 
MassHp[2][generation_] ->MassRead[Hp[2]], 
MassFd[1][generation_] ->MassGiven[Fd[1]], 
MassFd[2][generation_] ->MassGiven[Fd[2]], 
MassFd[3][generation_] ->MassGiven[Fd[3]], 
MassFd[1][generation_] ->MassGiven[Fd[1]], 
MassFd[2][generation_] ->MassGiven[Fd[2]], 
MassFd[3][generation_] ->MassGiven[Fd[3]], 
MassFu[1][generation_] ->MassGiven[Fu[1]], 
MassFu[2][generation_] ->MassGiven[Fu[2]], 
MassFu[3][generation_] ->MassGiven[Fu[3]], 
MassFu[1][generation_] ->MassGiven[Fu[1]], 
MassFu[2][generation_] ->MassGiven[Fu[2]], 
MassFu[3][generation_] ->MassGiven[Fu[3]], 
MassFe[1][generation_] ->MassGiven[Fe[1]], 
MassFe[2][generation_] ->MassGiven[Fe[2]], 
MassFe[3][generation_] ->MassGiven[Fe[3]], 
MassFe[1][generation_] ->MassGiven[Fe[1]], 
MassFe[2][generation_] ->MassGiven[Fe[2]], 
MassFe[3][generation_] ->MassGiven[Fe[3]]
}; 
 
 
(* NumericalValues *) 
 
NumericalValues = 
 {WidthGiven[VB] -> 0, MassGiven[VB] -> 0, WidthGiven[gB] -> 0, MassGiven[gB] -> 0, WidthGiven[VWB] -> 0, MassGiven[VWB] -> 0, WidthGiven[gWB] -> 0, MassGiven[gWB] -> 0, WidthGiven[VG] -> 0, MassGiven[VG] -> 0, WidthGiven[gG] -> 0, MassGiven[gG] -> 0, WidthGiven[VG] -> 0, MassGiven[VG] -> 0, WidthGiven[gG] -> 0, MassGiven[gG] -> 0, WidthGiven[Fv[1]] -> 0, WidthGiven[Fv[2]] -> 0, WidthGiven[Fv[3]] -> 0, MassGiven[Fv[1]] -> 0, MassGiven[Fv[2]] -> 0, MassGiven[Fv[3]] -> 0, WidthGiven[G0] -> {0}, MassGiven[G0] -> {0}, MassGiven[A0] -> Mass, MassGiven[H0] -> Mass, WidthGiven[VP] -> 0, MassGiven[VP] -> 0, WidthGiven[VZ] -> 2.4952, MassGiven[VZ] -> 91.1876, WidthGiven[gP] -> 0, MassGiven[gP] -> 0, MassGiven[gZ] -> Mass[VZ], WidthGiven[VWp] -> 2.141, MassGiven[gWp] -> Mass[VWp], MassGiven[gWpC] -> Mass[VWp], WidthGiven[Hp[1]] -> 0, MassGiven[Hp[1]] -> 0, WidthGiven[Fd[1]] -> 0, WidthGiven[Fd[2]] -> 0, WidthGiven[Fd[3]] -> 0, MassGiven[Fd[1]] -> 0.0035, MassGiven[Fd[2]] -> 0.104, MassGiven[Fd[3]] -> 4.2, WidthGiven[Fd[1]] -> 0, WidthGiven[Fd[2]] -> 0, WidthGiven[Fd[3]] -> 0, MassGiven[Fd[1]] -> 0.0035, MassGiven[Fd[2]] -> 0.104, MassGiven[Fd[3]] -> 4.2, WidthGiven[Fu[1]] -> 0, WidthGiven[Fu[2]] -> 0, WidthGiven[Fu[3]] -> 1.51, MassGiven[Fu[1]] -> 0.0015, MassGiven[Fu[2]] -> 1.27, MassGiven[Fu[3]] -> 171.2, WidthGiven[Fu[1]] -> 0, WidthGiven[Fu[2]] -> 0, WidthGiven[Fu[3]] -> 1.51, MassGiven[Fu[1]] -> 0.0015, MassGiven[Fu[2]] -> 1.27, MassGiven[Fu[3]] -> 171.2, WidthGiven[Fe[1]] -> 0, WidthGiven[Fe[2]] -> 0, WidthGiven[Fe[3]] -> 0, MassGiven[Fe[1]] -> 0.000511, MassGiven[Fe[2]] -> 0.105, MassGiven[Fe[3]] -> 1.776, WidthGiven[Fe[1]] -> 0, WidthGiven[Fe[2]] -> 0, WidthGiven[Fe[3]] -> 0, MassGiven[Fe[1]] -> 0.000511, MassGiven[Fe[2]] -> 0.105, MassGiven[Fe[3]] -> 1.776, AlphaS -> 0.119, Gf -> 0.0000116639, aEWinv -> 137.035999679}
 
 
